
CLASS: WindowC

       var vWidth
       var vHeight
       var vX
       var vY
       var vText
       char vVisible

       var handle
       var hParent
       var vStyle
       var vExStyle
       var vMenu

       var lparam
       var wparam
       var message
       var hwnd


VM: Type S" Static" ;

VM: Style 0 ;
VM: ExStyle 0 ;

M: pos ( x y -- ) vY ! vX ! ;
M: size ( w h -- ) vHeight ! vWidth ! ;

M: text ( a u -- )
    vText @ ?DUP IF FREE DROP THEN
    S>ZALLOC vText !
    ;




CONSTR: init
    CW_USEDEFAULT vWidth !
    CW_USEDEFAULT vHeight !
    CW_USEDEFAULT vX !
    CW_USEDEFAULT vY !
;

VM: CreateMenu 0 ;

M: visible   1 vVisible C! ;
M: invisible 0 vVisible C! ;
M: v visible ;
M: v- invisible ;

M: Show   visible SW_SHOW handle @ ShowWindow DROP  ;
M: ?Show  vVisible C@ 0= IF Show THEN ;
M: Hide   invisible SW_HIDE handle @ ShowWindow DROP  ;
M: ?Hide  vVisible C@ IF Hide THEN ;


M: Create { owner -- }
    this
    HINST
    CreateMenu DUP vMenu !
    hParent @ ?DUP 0= IF  owner DUP IF => handle @ THEN THEN
    DUP hParent !
    vHeight @ vWidth @ vY @ vX @
    Style vStyle @ OR
        owner 0= IF WS_OVERLAPPED ELSE WS_CHILD  THEN OR
    vText @
    Type DROP
    ExStyle vExStyle @ OR
    CreateWindowExA
    DUP 0= IF  GetLastError THROW THEN
    handle !
    this GWL_USERDATA handle @ SetWindowLongA DROP
    vVisible C@ IF Show THEN
;

M: FillMessage ( l w m h -- )
     hwnd !
     message !
     wparam !
     lparam !
;

M: SendMessage ( lParam wParam msg -- res )  handle @ SendMessageA ;

M: Close ( code -- ) PostQuitMessage DROP ;

M: Move { x y w h -- }
    -1 w h ToPixels 2DUP size SWAP
       x y ToPixels 2DUP pos SWAP
       handle @ MoveWindow DROP
;
M: MovePixels { x y w h -- }   -1 h w y x handle @ MoveWindow DROP ;

M: SetSizePixels { w h -- }
    SWP_NOMOVE ( SWP_NOREDRAW OR)
    h w 0 0 HWND_TOP handle @ SetWindowPos DROP ;

M: SetSize ( w h -- ) ToPixels SetSizePixels ;

M: SetPos { x y -- }
    SWP_NOSIZE ( SWP_NOREDRAW OR)
    0 0 y x HWND_TOP handle @ SetWindowPos DROP ;

M: SetPosU { x y -- } x y ToPixels SetPos ;

M: GetRect ( -- bottom right top left )
    0 0 0 0 SP@ handle @ GetWindowRect DROP ;

M: GetPos ( -- x y )  GetRect 2SWAP 2DROP SWAP ;

M: GetWindowSize ( -- x y ) GetRect ROT SWAP - ROT ROT - ;

M: Center ( w h -- )
    0 ROT ROT ToPixels SWAP
    2DUP SWAP GetDesktopSize   ROT - 2 / ROT ROT SWAP - 2 /
    HWND_TOP handle @
    SetWindowPos DROP
;

DESTR: free
     handle @ IsWindow IF handle @ DestroyWindow DROP THEN
\     free
;

M: ParentObj  handle @ GetParent HANDLE>OBJ ;

M: GetText ( -- addr u )
    vText @ ?DUP IF FREE DROP THEN
    handle @ GetWindowTextLengthA 1+ DUP  ALLOCATE THROW DUP vText !
    handle @ GetWindowTextA
    vText @ SWAP
;

M: SetText ( addr u -- )
    text vText @ handle @ SetWindowTextA DROP ;

M: Update   handle @ UpdateWindow DROP ;

M: Disable  FALSE handle @ EnableWindow DROP ;

M: Enable   TRUE handle @ EnableWindow DROP ;

M: SetFont ( hfont -- )   0 SWAP WM_SETFONT handle @ SendMessageA DROP ;
M: GetFont ( -- hfont )   0 0 WM_GETFONT handle @ SendMessageA ;

M: AddStyle ( u -- )
    GWL_STYLE handle @ GetWindowLongA
    OR GWL_STYLE handle @ SetWindowLongA DROP
;


M: SetFocus handle @ SetFocus DROP ;

M: isActive GetFocus handle @ = ;

M: TextOut ( addr u x y)
   2>R SWAP 2R> SWAP
   handle @ GetDC
   TextOutA DROP
;

: M:: ( c "WM_..." -- )
  \   
  \ c -   
  BASE @ >R
  NextWord EVALUATE HEX \    Windows  
  0 <# # # # #  # # # # ROT HOLD BL HOLD [CHAR] : HOLD #>
  EVALUATE
  R> BASE !
;

: W: [CHAR] W M:: ; \ WM_...
: C: [CHAR] C M:: ; \ WM_COMMAND
: N: [CHAR] N M:: ; \ WM_NOTIFY
: P: [CHAR] P M:: ; \ WM_PARENTNOTIFY
: MM: [CHAR] M M:: ; \ 


;CLASS
